# -*- coding: utf-8 -*-
"""
Helper functions for TOAR database

"""
from sqlalchemy import Table
from sqlalchemy.orm import Session
from collections import namedtuple

# get the controlled vocabulary from table
def __get_enum_dict(db: Session, table: Table):
    Enumdict=namedtuple("Dict",["value","string","display_str"])
    enum_dict = []
    for entry in db.query(table).all():
        enum_dict.append(Enumdict(*entry))
    return enum_dict

# function to return code for given value
def get_str_from_value(db: Session, table: Table, value: int) -> str:
    enum_error = "Invalid " + table.name
    enum_dict = __get_enum_dict(db, table)
    enum_entry = tuple(filter(lambda x: x.value == value, enum_dict))
    return enum_entry[0].string

    raise ValueError(enum_error)

# function to return value for given code
def get_value_from_str(db: Session, table: Table, string: str) -> int:
    enum_error = "Invalid " + table.name
    enum_dict = __get_enum_dict(db, table)
    enum_entry = tuple(filter(lambda x: x.string == string, enum_dict))
    return enum_entry[0].value

    raise ValueError(enum_error)
